unit unitportdetectdemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls;

type
  TformLPTConv = class(TForm)
    groupBoxLPT: TGroupBox;
    buttonRefresh: TButton;
    groupBoxCOM: TGroupBox;
    listViewCOM: TListView;
    listViewLPT: TListView;
    procedure buttonRefreshClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formLPTConv: TformLPTConv;

implementation

{$R *.dfm}

uses
  unitportdetect;

const
  COM_COUNT = 256;
  LPT_COUNT = 8;

procedure TformLPTConv.buttonRefreshClick(Sender: TObject);
var
  comPorts: array[0..COM_COUNT - 1] of TDetectedPort;
  lptPorts: array[0..LPT_COUNT - 1] of TDetectedPort;
  i: Integer;
begin
  getCOMPorts(comPorts);
  getLPTPorts(lptPorts);
  listViewCOM.Items.Clear();
  for i := 0 to COM_COUNT - 1 do
  begin
    with comPorts[i] do
    begin
      if friendlyName <> '' then
        with listViewCOM.Items.Add() do
        begin
          Caption := IntToStr(i + 1);
          SubItems.Add(friendlyName);
          if portLength > 0 then
          begin
            SubItems.Add('0x' + IntToHex(portStart, 3));
            SubItems.Add(IntToStr(portLength));
          end;
          if irq then
            SubItems.Add(IntToStr(irqLevel));
          if dma then
            SubItems.Add(IntToStr(dmaChannel));
        end;
    end;
  end;
  listViewLPT.Items.Clear();
  for i := 0 to LPT_COUNT - 1 do
  begin
    with lptPorts[i] do
    begin
      if friendlyName <> '' then
        with listViewLPT.Items.Add() do
        begin
          Caption := IntToStr(i + 1);
          SubItems.Add(friendlyName);
          if portLength > 0 then
          begin
            SubItems.Add('0x' + IntToHex(portStart, 3));
            SubItems.Add(IntToStr(portLength));
          end;
          if irq then
            SubItems.Add(IntToStr(irqLevel));
          if dma then
            SubItems.Add(IntToStr(dmaChannel));
        end;
      end;
  end;
end;

end.
